/*
 *  PathStroke.cpp
 *  nlivarot
 *
 *  Created by fred on Tue Jun 17 2003.
 *
 */

#include "Path.h"
#include "Shape.h"

// until i find something better
NR::Point StrokeNormalize(const NR::Point v) {
	double l = L2(v); 
    if ( l < 0.0000001 ) { 
		return NR::Point(0, 0);
    } else { 
		return v/l; 
    }
}

void
Path::Stroke (Shape * dest, bool doClose, double width, JoinType join,
              ButtType butt, double miter, bool justAdd)
{
	if (dest == NULL)
		return;
	if (justAdd == false)
	{
		dest->Reset (3 * nbPt, 3 * nbPt);
	}
	if (nbPt <= 1)
		return;
	dest->MakeBackData (false);
  
	char *savPts = pts;
	int savNbPt = nbPt;
  
	int lastM = 0;
	while (lastM < savNbPt)
	{
		int lastP = lastM + 1;
		if (back)
		{
			{
				path_lineto_b *tp = (path_lineto_b *) savPts;
				while (lastP < savNbPt
					   && ((tp + lastP)->isMoveTo == polyline_lineto
						   || (tp + lastP)->isMoveTo == polyline_forced))
					lastP++;
				pts = (char *) (tp + lastM);
				nbPt = lastP - lastM;
			}
		}
		else
		{
			{
				path_lineto *tp = (path_lineto *) savPts;
				while (lastP < savNbPt
					   && ((tp + lastP)->isMoveTo == polyline_lineto
						   || (tp + lastP)->isMoveTo == polyline_forced))
					lastP++;
				pts = (char *) (tp + lastM);
				nbPt = lastP - lastM;
			}
		}
		DoStroke (dest, doClose, width, join, butt, miter, true);
		lastM = lastP;
	}
  
	pts = savPts;
	nbPt = savNbPt;
}

void
Path::DoStroke (Shape * dest, bool doClose, double width, JoinType join,
                ButtType butt, double miter, bool justAdd)
{
	if (nbPt <= 1)
		return;
  
	NR::Point curP, prevP, nextP;
	int curI, prevI, nextI;
	int upTo;
  
	curI = 0;
	curP = ((path_lineto *) pts)[0].p;
  
	if (doClose)
	{
		path_lineto *curPt = (path_lineto *) pts;
		prevI = nbPt - 1;
		if (back)
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 prevI * sizeof (path_lineto_b));
		}
		else
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 prevI * sizeof (path_lineto));
		}
		while (prevI > 0)
		{
			prevP = curPt->p;
			NR::Point diff=curP-prevP;
			double dist =dot(diff,diff);
			if (dist > 0.001)
			{
				break;
			}
			prevI--;
			if (back)
			{
				curPt =
					(path_lineto *) (((char *) curPt) - sizeof (path_lineto_b));
			}
			else
			{
				curPt =
					(path_lineto *) (((char *) curPt) - sizeof (path_lineto));
			}
		}
		if (prevI <= 0)
			return;
		upTo = prevI;
	}
	else
	{
		prevP = curP;
		prevI = curI;
		upTo = nbPt - 1;
	}
	{
		path_lineto *curPt = (path_lineto *) pts;
		nextI = 1;
		if (back)
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 nextI * sizeof (path_lineto_b));
		}
		else
		{
			curPt =
				(path_lineto *) (((char *) curPt) + nextI * sizeof (path_lineto));
		}
		while (nextI <= upTo)
		{
			nextP = curPt->p;
			NR::Point diff=curP-nextP;
			double dist =dot(diff,diff);
			if (dist > 0.001)
			{
				break;
			}
			nextI++;
			if (back)
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto_b));
			}
			else
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto));
			}
		}
		if (nextI > upTo)
			return;
	}
  
	int startLeft = -1, startRight = -1;
	int lastLeft = -1, lastRight = -1;
	NR::Point prevD = curP - prevP;
	NR::Point nextD = nextP - curP;
	double prevLe = NR::L2(prevD);
	double nextLe = NR::L2(nextD);
	prevD = StrokeNormalize (prevD);
	nextD = StrokeNormalize (nextD);
	if (doClose)
	{
		DoJoin (dest,  width, join, curP, prevD, nextD, miter, prevLe,
				nextLe, startLeft, lastLeft, startRight, lastRight);
	}
	else
	{
		nextD = -nextD;
		DoButt (dest,  width, butt, curP, nextD, lastRight, lastLeft);
		nextD = -nextD;
	}
	do
	{
		prevP = curP;
		prevI = curI;
		curP = nextP;
		curI = nextI;
		prevD = nextD;
		prevLe = nextLe;
		nextI++;
		path_lineto *curPt = (path_lineto *) pts;
		if (back)
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 nextI * sizeof (path_lineto_b));
		}
		else
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 nextI * sizeof (path_lineto));
		}
		while (nextI <= upTo)
		{
			nextP = curPt->p;
			NR::Point diff=curP-nextP;
			double dist =dot(diff,diff);
			if (dist > 0.001)
			{
				break;
			}
			nextI++;
			if (back)
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto_b));
			}
			else
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto));
			}
		}
		if (nextI > upTo)
			break;
    
		nextD = nextP - curP;
		nextLe = NR::L2(nextD);
		nextD = StrokeNormalize (nextD);
		int nStL = -1, nStR = -1, nEnL = -1, nEnR = -1;
		DoJoin (dest,  width, join, curP, prevD, nextD, miter, prevLe,
				nextLe, nStL, nEnL, nStR, nEnR);
		dest->AddEdge (nStL, lastLeft);
		lastLeft = nEnL;
		dest->AddEdge (lastRight, nStR);
		lastRight = nEnR;
	}
	while (nextI <= upTo);
	if (doClose)
	{
		/*		prevP=curP;
				prevI=curI;
				curP=nextP;
				curI=nextI;
				prevD=nextD;*/
		path_lineto *curPt = (path_lineto *) pts;
		nextP = curPt->p;

		nextD = nextP - curP;
		nextLe = NR::L2(nextD);
		nextD = StrokeNormalize (nextD);
		int nStL = -1, nStR = -1, nEnL = -1, nEnR = -1;
		DoJoin (dest,  width, join, curP, prevD, nextD, miter, prevLe,
				nextLe, nStL, nEnL, nStR, nEnR);
		dest->AddEdge (nStL, lastLeft);
		lastLeft = nEnL;
		dest->AddEdge (lastRight, nStR);
		lastRight = nEnR;
    
		dest->AddEdge (startLeft, lastLeft);
		dest->AddEdge (lastRight, startRight);
	}
	else
	{
		int endRight, endLeft;
		DoButt (dest,  width, butt, curP, prevD, endLeft, endRight);
		dest->AddEdge (endLeft, lastLeft);
		dest->AddEdge (lastRight, endRight);
	}
}
void
Path::DoButt (Shape * dest, double width, ButtType butt, NR::Point pos, NR::Point dir,
              int &leftNo, int &rightNo)
{
	NR::Point nor;
	nor=dir.ccw();
  
	if (butt == butt_square)
	{
		NR::Point x;
		x = pos + width * dir + width * nor;
		int bleftNo = dest->AddPoint (x);
		x = pos + width * dir - width * nor;
		int brightNo = dest->AddPoint (x);
		x = pos + width * nor;
		leftNo = dest->AddPoint (x);
		x = pos - width * nor;
		rightNo = dest->AddPoint (x);
		dest->AddEdge (rightNo, brightNo);
		dest->AddEdge (brightNo, bleftNo);
		dest->AddEdge (bleftNo, leftNo);
	}
	else if (butt == butt_pointy)
	{
		leftNo = dest->AddPoint (pos + width * nor);
		rightNo = dest->AddPoint (pos - width * nor);
		int mid = dest->AddPoint (pos + width * dir);
		dest->AddEdge (rightNo, mid);
		dest->AddEdge (mid, leftNo);
	}
	else if (butt == butt_round)
	{
		const NR::Point sx = pos + width * nor;
		const NR::Point ex = pos - width * nor;
		const NR::Point mx = pos + width * dir;
		leftNo = dest->AddPoint (sx);
		rightNo = dest->AddPoint (ex);
		int midNo = dest->AddPoint (mx);
    
		NR::Point dx = pos - width * nor + width * dir;
		RecRound (dest, rightNo, midNo, dx, ex, mx, 5.0, 8);
		dx = pos + width * nor + width * dir;
		RecRound (dest, midNo, leftNo, dx, mx, sx, 5.0, 8);
	}
	else
	{
		leftNo = dest->AddPoint (pos + width * nor);
		rightNo = dest->AddPoint (pos - width * nor);
		dest->AddEdge (rightNo, leftNo);
	}
}
void
Path::DoJoin (Shape * dest, double width, JoinType join, NR::Point pos, NR::Point prev,
              NR::Point next, double miter, double prevL, double nextL, int &leftStNo,
              int &leftEnNo, int &rightStNo, int &rightEnNo)
{
	//      DoLeftJoin(dest,width,join,pos,prev,next,miter,prevL,nextL,leftStNo,leftEnNo);
	//      DoRightJoin(dest,width,join,pos,prev,next,miter,prevL,nextL,rightStNo,rightEnNo);
	//      return;
  
	NR::Point pnor=prev.ccw();
	NR::Point nnor=next.ccw();
	double angSi = cross (next, prev);
	if (angSi > -0.0001 && angSi < 0.0001)
	{
		double angCo = dot (prev, next);
		if (angCo > 0.9999)
		{
			// tout droit
			leftStNo = leftEnNo = dest->AddPoint (pos + width * pnor);
			rightStNo = rightEnNo = dest->AddPoint (pos - width * pnor);
		}
		else
		{
			// demi-tour
			leftStNo = rightEnNo = dest->AddPoint (pos + width * pnor);
			rightStNo = leftEnNo = dest->AddPoint (pos - width * pnor);
			dest->AddEdge (leftEnNo, leftStNo);
			dest->AddEdge (rightStNo, rightEnNo);
		}
		return;
	}
	if (angSi < 0)
	{
		NR::Point x;
		{
			NR::Point biss = next - prev;
			double c2 = cross (biss, next);
			double l = width / c2;
			double projn = l * (dot (biss, next));
			double projp = -l * (dot (biss, prev));
			if (projp <= 0.5 * prevL && projn <= 0.5 * nextL)
			{
				leftEnNo = leftStNo = dest->AddPoint (pos + l * biss);
			}
			else
			{
				leftStNo = dest->AddPoint (pos + width * pnor);
				leftEnNo = dest->AddPoint (pos + width * nnor);
				dest->AddEdge (leftEnNo, leftStNo);
			}
		}
		if (join == join_pointy)
		{
			rightStNo = dest->AddPoint (pos - width * pnor);
			rightEnNo = dest->AddPoint (pos - width * nnor);
      
			//                      dest->AddEdge(rightStNo,rightEnNo);
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			double c2 = dot (biss, nnor);
			double l = width / c2;
			double emiter = width * c2;
			if (emiter < miter)
				emiter = miter;
			int nrightStNo, nrightEnNo;
			if (l <= emiter)
			{
				nrightStNo = nrightEnNo = dest->AddPoint (pos - l * biss);
			}
			else
			{
				double s2 = cross (biss, nnor);
				double dec = (l - emiter) * c2 / s2;
				NR::Point tbiss=biss.ccw();
        
				nrightStNo = dest->AddPoint (pos - emiter*biss - dec*tbiss);
				nrightEnNo = dest->AddPoint (pos - emiter*biss + dec*tbiss);
			}
			dest->AddEdge (rightStNo, nrightStNo);
			dest->AddEdge (nrightStNo, nrightEnNo);
			dest->AddEdge (nrightEnNo, rightEnNo);
		}
		else if (join == join_round)
		{
			NR::Point sx = pos - width * pnor;
			rightStNo = dest->AddPoint (sx);
			NR::Point ex = pos - width * nnor;
			rightEnNo = dest->AddPoint (ex);
      
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			double c2 = dot (biss, nnor);
			double l = width / c2;
			double typ = dot (pnor, nnor);
			if (typ >= 0)
			{
				RecRound (dest, rightStNo, rightEnNo, pos - l * biss, 
						  sx, ex, 5.0, 8);
			}
			else
			{
				double s2 = cross (biss, nnor);
				double dec = (l - width) * c2 / s2;
				NR::Point tbiss=biss.ccw();
        
				NR::Point nsx = pos - width * biss - dec * tbiss;
				NR::Point nex = pos - width * biss + dec * tbiss;
				NR::Point mx = pos - width * biss;
				int midNo = dest->AddPoint (mx);
				RecRound (dest, rightStNo, midNo, nsx, sx, mx, 5.0,
						  8);
				RecRound (dest, midNo, rightEnNo, nex, mx, ex, 5.0,
						  8);
			}
		}
		else
		{
			rightStNo = dest->AddPoint (pos - width * pnor);
			rightEnNo = dest->AddPoint (pos - width * nnor);
			dest->AddEdge (rightStNo, rightEnNo);
		}
	}
	else
	{
		{
			NR::Point biss;
			biss = next - prev;
			double c2 = cross (next, biss);
			double l = width / c2;
			double projn = l * (dot (biss, next));
			double projp = -l * (dot (biss, prev));
			if (projp <= 0.5 * prevL && projn <= 0.5 * nextL)
			{
				rightEnNo = rightStNo = dest->AddPoint (pos + l * biss);
			}
			else
			{
				rightStNo = dest->AddPoint (pos - width * pnor);
				rightEnNo = dest->AddPoint (pos - width * nnor);
				dest->AddEdge (rightStNo, rightEnNo);
			}
		}
		if (join == join_pointy)
		{
			leftStNo = dest->AddPoint (pos + width * pnor);
			leftEnNo = dest->AddPoint (pos + width * nnor);
			//              dest->AddEdge(leftEnNo,leftStNo);
      
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			double c2 = dot (biss, nnor);
			double l = width / c2;
			double emiter = width * c2;
			if (emiter < miter)
				emiter = miter;
			int nleftStNo, nleftEnNo;
			if (l <= emiter)
			{
				nleftStNo = nleftEnNo = dest->AddPoint (pos + l * biss);
			}
			else
			{
				double s2 = cross (biss, nnor);
				double dec = (l - emiter) * c2 / s2;
				NR::Point tbiss=biss.ccw();
        
				nleftStNo = dest->AddPoint (pos + emiter*biss + dec*tbiss);
				nleftEnNo = dest->AddPoint (pos + emiter*biss - dec*tbiss);
			}
			dest->AddEdge (leftEnNo, nleftEnNo);
			dest->AddEdge (nleftEnNo, nleftStNo);
			dest->AddEdge (nleftStNo, leftStNo);
		}
		else if (join == join_round)
		{
			NR::Point sx = pos + width * pnor;
			leftStNo = dest->AddPoint (sx);
			NR::Point ex = pos + width * nnor;
			leftEnNo = dest->AddPoint (ex);
      
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			double c2 = dot (biss, nnor);
			double l = width / c2;
			double typ = dot (pnor, nnor);
			if (typ >= 0)
			{
				RecRound (dest, leftEnNo, leftStNo, 
						  pos + l * biss, ex, sx, 5.0, 8);
			}
			else
			{
				double s2 = cross (biss, nnor);
				double dec = (l - width) * c2 / s2;
				NR::Point tbiss=biss.ccw();
        
				NR::Point mx = pos + width * biss;
				int midNo = dest->AddPoint (mx);
        
				NR::Point nsx = pos + width * biss + dec * tbiss;
				NR::Point nex = pos + width * biss - dec * tbiss;
				RecRound (dest, leftEnNo, midNo, nex, ex, mx, 5.0,
						  8);
				RecRound (dest, midNo, leftStNo, nsx, mx, sx, 5.0,
						  8);
			}
		}
		else
		{
			leftStNo = dest->AddPoint (pos + width * pnor);
			leftEnNo = dest->AddPoint (pos + width * nnor);
			dest->AddEdge (leftEnNo, leftStNo);
		}
	}
}

void
Path::DoLeftJoin (Shape * dest, double width, JoinType join, NR::Point pos,
                  NR::Point prev, NR::Point next, double miter, double prevL, double nextL,
                  int &leftStNo, int &leftEnNo,int pathID,int pieceID,double tID)
{
	NR::Point pnor=prev.ccw();
	NR::Point nnor=next.ccw();
	double angSi = cross (next, prev);
	if (angSi > -0.0001 && angSi < 0.0001)
	{
		double angCo = dot (prev, next);
		if (angCo > 0.9999)
		{
			// tout droit
			leftEnNo = leftStNo = dest->AddPoint (pos + width * pnor);
		}
		else
		{
			// demi-tour
			leftStNo = dest->AddPoint (pos + width * pnor);
			leftEnNo = dest->AddPoint (pos - width * pnor);
			int nEdge=dest->AddEdge (leftEnNo, leftStNo);
			if ( dest->HasBackData() ) {
				dest->ebData[nEdge].pathID=pathID;
				dest->ebData[nEdge].pieceID=pieceID;
				dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
			}
		}
		return;
	}
	if (angSi < 0)
	{
		/*		NR::Point     biss;
				biss.x=next.x-prev.x;
				biss.y=next.y-prev.y;
				double   c2=cross(biss,next);
				double   l=width/c2;
				double		projn=l*(dot(biss,next));
				double		projp=-l*(dot(biss,prev));
				if ( projp <= 0.5*prevL && projn <= 0.5*nextL ) {
				double   x,y;
				x=pos.x+l*biss.x;
				y=pos.y+l*biss.y;
				leftEnNo=leftStNo=dest->AddPoint(x,y);
				} else {*/
		leftStNo = dest->AddPoint (pos + width * pnor);
		leftEnNo = dest->AddPoint (pos + width * nnor);
		int midNo = dest->AddPoint (pos);
		int nEdge=dest->AddEdge (leftEnNo, midNo);
		if ( dest->HasBackData() ) {
			dest->ebData[nEdge].pathID=pathID;
			dest->ebData[nEdge].pieceID=pieceID;
			dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
		}
		nEdge=dest->AddEdge (midNo, leftStNo);
		if ( dest->HasBackData() ) {
			dest->ebData[nEdge].pathID=pathID;
			dest->ebData[nEdge].pieceID=pieceID;
			dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
		}
		//              }
	}
	else
	{
		if (join == join_pointy)
		{
			leftStNo = dest->AddPoint (pos + width * pnor);
			leftEnNo = dest->AddPoint (pos + width * nnor);
      
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			double c2 = dot (biss, nnor);
			double l = width / c2;
			double emiter = width * c2;
			if (emiter < miter)
				emiter = miter;
			if (l <= emiter)
			{
				int nleftStNo = dest->AddPoint (pos + l * biss);
				int nEdge=dest->AddEdge (leftEnNo, nleftStNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
				nEdge=dest->AddEdge (nleftStNo, leftStNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
			}
			else
			{
				double s2 = cross (biss, nnor);
				double dec = (l - emiter) * c2 / s2;
				const NR::Point tbiss=biss.ccw();
        
				int nleftStNo = dest->AddPoint (pos + emiter * biss + dec * tbiss);
				int nleftEnNo = dest->AddPoint (pos + emiter * biss - dec * tbiss);
				int nEdge=dest->AddEdge (nleftEnNo, nleftStNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
				nEdge=dest->AddEdge (leftEnNo, nleftEnNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
				nEdge=dest->AddEdge (nleftStNo, leftStNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
			}
		}
		else if (join == join_round)
		{
			const NR::Point sx = pos + width * pnor;
			leftStNo = dest->AddPoint (sx);
			const NR::Point ex = pos + width * nnor;
			leftEnNo = dest->AddPoint (ex);
      
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			const double c2 = dot (biss, nnor);
			const double l = width / c2;
			const double typ = dot (pnor, nnor);
			if (typ >= 0)
			{
				RecRound (dest, leftEnNo, leftStNo, pos + l * biss, ex, sx, 5.0,
						  8);
			}
			else
			{
				const double s2 = cross (biss, nnor);
				const double dec = (l - width) * c2 / s2;
				const NR::Point tbiss=biss.ccw();
        
				const NR::Point mx = pos + width * biss;
				const int midNo = dest->AddPoint (mx);
        
				const NR::Point nsx = pos + width * biss + dec * tbiss;
				const NR::Point nex = pos + width * biss - dec * tbiss;
				RecRound (dest, leftEnNo, midNo, nex, ex, mx, 5.0,
						  8);
				RecRound (dest, midNo, leftStNo, nsx, mx, sx, 5.0,
						  8);
			}
		}
		else
		{
			leftStNo = dest->AddPoint (pos + width * pnor);
			leftEnNo = dest->AddPoint (pos + width * nnor);
			int nEdge=dest->AddEdge (leftEnNo, leftStNo);
			if ( dest->HasBackData() ) {
				dest->ebData[nEdge].pathID=pathID;
				dest->ebData[nEdge].pieceID=pieceID;
				dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
			}
		}
	}
}
void
Path::DoRightJoin (Shape * dest, double width, JoinType join, NR::Point pos,
                   NR::Point prev, NR::Point next, double miter, double prevL,
                   double nextL, int &rightStNo, int &rightEnNo,int pathID,int pieceID,double tID)
{
	const NR::Point pnor=prev.ccw();
	const NR::Point nnor=next.ccw();
	double angSi = cross (next,prev);
	if (angSi > -0.0001 && angSi < 0.0001)
	{
		double angCo = dot (prev, next);
		if (angCo > 0.9999)
		{
			// tout droit
			rightEnNo = rightStNo = dest->AddPoint (pos - width*pnor);
		}
		else
		{
			// demi-tour
			rightEnNo = dest->AddPoint (pos + width*pnor);
			rightStNo = dest->AddPoint (pos - width*pnor);
			int nEdge=dest->AddEdge (rightStNo, rightEnNo);
			if ( dest->HasBackData() ) {
				dest->ebData[nEdge].pathID=pathID;
				dest->ebData[nEdge].pieceID=pieceID;
				dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
			}
		}
		return;
	}
	if (angSi < 0)
	{
		if (join == join_pointy)
		{
			rightStNo = dest->AddPoint (pos - width*pnor);
			rightEnNo = dest->AddPoint (pos - width*nnor);
      
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			double c2 = dot (biss, nnor);
			double l = width / c2;
			double emiter = width * c2;
			if (emiter < miter)
				emiter = miter;
			if (l <= emiter)
			{
				int nrightStNo = dest->AddPoint (pos - l * biss);
				int nEdge=dest->AddEdge (rightStNo, nrightStNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
				nEdge=dest->AddEdge (nrightStNo, rightEnNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
			}
			else
			{
				double s2 = cross (biss, nnor);
				double dec = (l - emiter) * c2 / s2;
				const NR::Point tbiss=biss.ccw();
        
				int nrightStNo = dest->AddPoint (pos - emiter*biss - dec*tbiss);
				int nrightEnNo = dest->AddPoint (pos - emiter*biss + dec*tbiss);
				int nEdge=dest->AddEdge (rightStNo, nrightStNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
				nEdge=dest->AddEdge (nrightStNo, nrightEnNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
				nEdge=dest->AddEdge (nrightEnNo, rightEnNo);
				if ( dest->HasBackData() ) {
					dest->ebData[nEdge].pathID=pathID;
					dest->ebData[nEdge].pieceID=pieceID;
					dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
				}
			}
		}
		else if (join == join_round)
		{
			const NR::Point sx = pos - width * pnor;
			rightStNo = dest->AddPoint (sx);
			const NR::Point ex = pos - width * nnor;
			rightEnNo = dest->AddPoint (ex);
      
			const NR::Point biss = StrokeNormalize (pnor + nnor);
			double c2 = dot (biss, nnor);
			double l = width / c2;
			double typ = dot (pnor, nnor);
			if (typ >= 0)
			{
				RecRound (dest, rightStNo, rightEnNo, pos - l*biss, 
						  sx, ex, 5.0, 8);
			}
			else
			{
				double s2 = cross (biss, nnor);
				double dec = (l - width) * c2 / s2;
				const NR::Point tbiss=biss.ccw();
        
				const NR::Point nsx = pos - width * biss - dec * tbiss;
				const NR::Point nex = pos - width * biss + dec * tbiss;
				const NR::Point mx = pos - width * biss;
				int midNo = dest->AddPoint (mx);
				RecRound (dest, rightStNo, midNo, nsx, sx, mx, 5.0,
						  8);
				RecRound (dest, midNo, rightEnNo, nex, mx, ex, 5.0,
						  8);
			}
		}
		else
		{
			rightStNo = dest->AddPoint (pos - width * pnor);
			rightEnNo = dest->AddPoint (pos - width * nnor);
			int nEdge=dest->AddEdge (rightStNo, rightEnNo);
			if ( dest->HasBackData() ) {
				dest->ebData[nEdge].pathID=pathID;
				dest->ebData[nEdge].pieceID=pieceID;
				dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
			}
		}
	}
	else
	{
		/*		NR::Point     biss;
				biss=next.x-prev.x;
				biss.y=next.y-prev.y;
				double   c2=cross(next,biss);
				double   l=width/c2;
				double		projn=l*(dot(biss,next));
				double		projp=-l*(dot(biss,prev));
				if ( projp <= 0.5*prevL && projn <= 0.5*nextL ) {
				double   x,y;
				x=pos.x+l*biss.x;
				y=pos.y+l*biss.y;
				rightEnNo=rightStNo=dest->AddPoint(x,y);
				} else {*/
		rightStNo = dest->AddPoint (pos - width*pnor);
		rightEnNo = dest->AddPoint (pos - width*nnor);
		int midNo = dest->AddPoint (pos);
		int nEdge=dest->AddEdge (rightStNo, midNo);
		if ( dest->HasBackData() ) {
			dest->ebData[nEdge].pathID=pathID;
			dest->ebData[nEdge].pieceID=pieceID;
			dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
		}
		nEdge=dest->AddEdge (midNo, rightEnNo);
		if ( dest->HasBackData() ) {
			dest->ebData[nEdge].pathID=pathID;
			dest->ebData[nEdge].pieceID=pieceID;
			dest->ebData[nEdge].tSt=dest->ebData[nEdge].tEn=tID;
		}
		//              }
	}
}


void
Path::RecRound (Shape * dest, int sNo, int eNo, NR::Point const &iP, NR::Point const &iS,NR::Point const &iE, double tresh, int lev)
{
	if (lev <= 0)
	{
		dest->AddEdge (sNo, eNo);
		return;
	}
	const double s = fabs(cross(iE-iP,iS-iP));
	if (s < tresh)
	{
		dest->AddEdge (sNo, eNo);
		return;
	}
  
	const NR::Point m = (iS + iE + 2 * iP) / 4;
	int mNo = dest->AddPoint (m);
  
	RecRound (dest, sNo, mNo, (iS + iP) / 2, iS, m, tresh, lev - 1);
	RecRound (dest, mNo, eNo, (iE + iP) / 2, m, iE, tresh, lev - 1);
}

/*
 *
 * dashed version
 *
 */

void
Path::Stroke (Shape * dest, bool doClose, double width, JoinType join,
              ButtType butt, double miter, int nbDash, one_dash * dashs,
              bool justAdd)
{
	if (nbDash <= 0)
	{
		Stroke (dest, doClose, width, join, butt, miter, justAdd);
		return;
	}
  
	if (dest == NULL)
		return;
	if (justAdd == false)
	{
		dest->Reset (3 * nbPt, 3 * nbPt);
	}
	if (nbPt <= 1)
		return;
	dest->MakeBackData (false);
  
	char *savPts = pts;
	int savNbPt = nbPt;
  
	int lastM = 0;
	while (lastM < savNbPt)
	{
		int lastP = lastM + 1;
		if (back)
		{
			{
				path_lineto_b *tp = (path_lineto_b *) savPts;
				while (lastP < savNbPt
					   && ((tp + lastP)->isMoveTo == polyline_lineto
						   || (tp + lastP)->isMoveTo == polyline_forced))
					lastP++;
				pts = (char *) (tp + lastM);
				nbPt = lastP - lastM;
			}
		}
		else
		{
			{
				path_lineto *tp = (path_lineto *) savPts;
				while (lastP < savNbPt
					   && ((tp + lastP)->isMoveTo == polyline_lineto
						   || (tp + lastP)->isMoveTo == polyline_forced))
					lastP++;
				pts = (char *) (tp + lastM);
				nbPt = lastP - lastM;
			}
		}
		DoStroke (dest, doClose, width, join, butt, miter, nbDash, dashs, true);
		lastM = lastP;
	}
  
	pts = savPts;
	nbPt = savNbPt;
}

void
Path::DoStroke (Shape * dest, bool doClose, double width, JoinType join,
                ButtType butt, double miter, int nbDash, one_dash * dashs,
                bool justAdd)
{
  
	if (dest == NULL)
		return;
	if (nbPt <= 1)
		return;
  
	NR::Point prevP, nextP;
	int prevI, nextI;
	int upTo;
	double curA, prevA, nextA;
	double dashPos = 0, dashAbs = 0;
	int dashNo = 0;
  
	int curI = 0;
	NR::Point curP = ((path_lineto *) pts)[0].p;
  
	if (doClose)
	{
		path_lineto *curPt = (path_lineto *) pts;
		prevI = nbPt - 1;
		if (back)
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 prevI * sizeof (path_lineto_b));
		}
		else
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 prevI * sizeof (path_lineto));
		}
		while (prevI > 0)
		{
			prevP = curPt->p;
			NR::Point diff=curP-prevP;
			double dist =dot(diff,diff);
			if (dist > 0.001)
			{
				break;
			}
			prevI--;
			if (back)
			{
				curPt =
					(path_lineto *) (((char *) curPt) - sizeof (path_lineto_b));
			}
			else
			{
				curPt =
					(path_lineto *) (((char *) curPt) - sizeof (path_lineto));
			}
		}
		if (prevI <= 0)
			return;
		upTo = prevI;
	}
	else
	{
		prevP = curP;
		prevI = curI;
		upTo = nbPt - 1;
	}
	{
		path_lineto *curPt = (path_lineto *) pts;
		nextI = 1;
		if (back)
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 nextI * sizeof (path_lineto_b));
		}
		else
		{
			curPt =
				(path_lineto *) (((char *) curPt) + nextI * sizeof (path_lineto));
		}
		while (nextI <= upTo)
		{
			nextP = curPt->p;
			NR::Point diff=curP-nextP;
			double dist =dot(diff,diff);
			if (dist > 0.001)
			{
				break;
			}
			nextI++;
			if (back)
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto_b));
			}
			else
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto));
			}
		}
		if (nextI > upTo)
			return;
	}
  
	int startLeft = -1, startRight = -1;
	int lastLeft = -1, lastRight = -1;
	bool noStartJoin = false, inGap = true;
	NR::Point prevD, nextD;
	double prevLe, nextLe;
	prevD = curP - prevP;
	nextD = nextP - curP;
	curA = 0;
	prevA = -NR::L2(prevD);
	nextA = NR::L2(nextD);
	prevLe = NR::L2(prevD);
	nextLe = NR::L2(nextD);
	prevD = StrokeNormalize (prevD);
	nextD = StrokeNormalize (nextD);
	dashTo_info dTo;
  
	{
		int cDashNo = dashNo;
		double nDashAbs = 0;
		do
		{
			if (dashAbs + (dashs[dashNo].length - dashPos) <= nDashAbs)
			{
				dashNo++;
				if (dashNo >= nbDash)
					dashNo -= nbDash;
				dashPos = 0;
			}
			else
			{
				break;
			}
		}
		while (dashNo != cDashNo);
	}
	if (doClose)
	{
		if (dashs[dashNo].gap)
		{
			noStartJoin = true;
			inGap = true;
		}
		else
		{
			noStartJoin = false;
			DoJoin (dest,  width, join, curP, prevD, nextD, miter, prevLe,
					nextLe, startLeft, lastLeft, startRight, lastRight);
			inGap = false;
		}
	}
	else
	{
		if (dashs[dashNo].gap)
		{
			inGap = true;
		}
		else
		{
			nextD = -nextD;
			DoButt (dest,  width, butt, curP, nextD, lastRight, lastLeft);
			nextD = -nextD;
			inGap = false;
		}
	}
	do
	{
		prevP = curP;
		prevI = curI;
		prevA = curA;
		curP = nextP;
		curI = nextI;
		curA = nextA;
		prevLe = nextLe;
		prevD = nextD;
		nextI++;
		path_lineto *curPt = (path_lineto *) pts;
		if (back)
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 nextI * sizeof (path_lineto_b));
		}
		else
		{
			curPt =
				(path_lineto *) (((char *) curPt) +
								 nextI * sizeof (path_lineto));
		}
		while (nextI <= upTo)
		{
			nextP = curPt->p;
			NR::Point   diff=curP-nextP;
			double dist =dot(diff,diff);
			if (dist > 0.001)
			{
				break;
			}
			nextI++;
			if (back)
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto_b));
			}
			else
			{
				curPt =
					(path_lineto *) (((char *) curPt) + sizeof (path_lineto));
			}
		}
		if (nextI > upTo)
			break;
    
		nextD= nextP - curP;
		nextA = curA + NR::L2(nextD);
		nextLe = NR::L2(nextD);
		nextD = StrokeNormalize (nextD);
    
		dTo.nDashAbs = curA;
		dTo.prevP = prevP;
		dTo.curP = curP;
		dTo.prevD = prevD;
		dTo.prevW =  width;
		dTo.curW =  width;
    
		DashTo (dest, &dTo, dashAbs, dashNo, dashPos, inGap, lastLeft,
				lastRight, nbDash, dashs);
    
		if (inGap == false)
		{
			int nStL = -1, nStR = -1, nEnL = -1, nEnR = -1;
			DoJoin (dest,  width, join, curP, prevD, nextD, miter, prevLe,
					nextLe, nStL, nEnL, nStR, nEnR);
			dest->AddEdge (nStL, lastLeft);
			lastLeft = nEnL;
			dest->AddEdge (lastRight, nStR);
			lastRight = nEnR;
		}
	}
	while (nextI <= upTo);
	if (doClose)
	{
		/*		prevP=curP;
				prevI=curI;
				prevA=curA;
				curP=nextP;
				curI=nextI;
				curA=nextA;
				prevD=nextD;*/
		path_lineto *curPt = (path_lineto *) pts;
		nextP = curPt->p;
    
		nextD = nextP - curP;
		nextA = curA + L2(nextD);
		nextLe = NR::L2(nextD);
		nextD = StrokeNormalize (nextD);
    
		dTo.nDashAbs = curA;
		dTo.prevP = prevP;
		dTo.curP = curP;
		dTo.prevD = prevD;
		dTo.prevW = width;
		dTo.curW =  width;
    
		DashTo (dest, &dTo, dashAbs, dashNo, dashPos, inGap, lastLeft,
				lastRight, nbDash, dashs);
		if (inGap == false)
		{
			int nStL = -1, nStR = -1, nEnL = -1, nEnR = -1;
			DoJoin (dest,  width, join, curP, prevD, nextD, miter, prevLe,
					nextLe, nStL, nEnL, nStR, nEnR);
			dest->AddEdge (nStL, lastLeft);
			lastLeft = nEnL;
			dest->AddEdge (lastRight, nStR);
			lastRight = nEnR;
		}
		dTo.nDashAbs = nextA;
		dTo.prevP = curP;
		dTo.curP = nextP;
		dTo.prevD = nextD;
		dTo.prevW =  width;
		dTo.curW =  width;
    
		DashTo (dest, &dTo, dashAbs, dashNo, dashPos, inGap, lastLeft,
				lastRight, nbDash, dashs);
    
		if (inGap == false)
		{
			if (noStartJoin == false)
			{
				dest->AddEdge (startLeft, lastLeft);
				dest->AddEdge (lastRight, startRight);
			}
			else
			{
				dest->AddEdge (lastRight, lastLeft);
			}
		}
		else
		{
			if (noStartJoin == false)
			{
				dest->AddEdge (startLeft, startRight);
			}
		}
	}
	else
	{
		dTo.nDashAbs = curA;
		dTo.prevP = prevP;
		dTo.curP = curP;
		dTo.prevD = prevD;
		dTo.prevW =  width;
		dTo.curW =  width;
    
		DashTo (dest, &dTo, dashAbs, dashNo, dashPos, inGap, lastLeft,
				lastRight, nbDash, dashs);
		if (inGap == false)
		{
			int endRight, endLeft;
			DoButt (dest,  width, butt, curP, prevD, endLeft, endRight);
			dest->AddEdge (endLeft, lastLeft);
			dest->AddEdge (lastRight, endRight);
		}
	}
  
}

void
Path::DashTo (Shape * dest, dashTo_info * dTo, double &dashAbs, int &dashNo,
              double &dashPos, bool & inGap, int &lastLeft, int &lastRight,
              int nbDash, one_dash * dashs)
{
	//      printf("%f %i %f %i -> %f\n",dashAbs,dashNo,dashPos,(inGap)?1:0,dTo->nDashAbs);
	NR::Point pnor = dTo->prevD.ccw();
  
	double oDashAbs = dashAbs;
	while (dashAbs < dTo->nDashAbs)
	{
		int cDashNo = dashNo;
		do
		{
			double delta = dashs[dashNo].length - dashPos;
			if (delta <= dTo->nDashAbs - dashAbs)
			{
				dashNo++;
				dashPos = 0;
				if (dashNo >= nbDash)
					dashNo -= nbDash;
				while (dashNo != cDashNo && dashs[dashNo].length <= 0)
				{
					dashNo++;
					dashPos = 0;
					if (dashNo >= nbDash)
						dashNo -= nbDash;
				}
				if (dashs[dashNo].length > 0)
				{
					dashAbs += delta;
					NR::Point pos =
						((dTo->nDashAbs - dashAbs) * dTo->prevP+
						 (dashAbs - oDashAbs)*dTo->curP) / (dTo->nDashAbs -
															oDashAbs);
					double nw =
						(dTo->prevW * (dTo->nDashAbs - dashAbs) +
						 dTo->curW * (dashAbs - oDashAbs)) / (dTo->nDashAbs -
															  oDashAbs);
          
					if (inGap && dashs[dashNo].gap == false)
					{
						int nleftNo = dest->AddPoint (pos + nw * pnor);
						int nrightNo = dest->AddPoint (pos - nw * pnor);
						dest->AddEdge (nleftNo, nrightNo);
						lastLeft = nleftNo;
						lastRight = nrightNo;
            
						inGap = false;
					}
					else if (inGap == false && dashs[dashNo].gap)
					{
						int nleftNo = dest->AddPoint (pos + nw * pnor);
						int nrightNo = dest->AddPoint (pos - nw * pnor);
						dest->AddEdge (nrightNo, nleftNo);
						dest->AddEdge (lastRight, nrightNo);
						dest->AddEdge (nleftNo, lastLeft);
						lastLeft = -1;
						lastRight = -1;
            
						inGap = true;
					}
					else
					{
            
					}
				}
			}
			else
			{
				dashPos += dTo->nDashAbs - dashAbs;
				dashAbs = dTo->nDashAbs;
				break;
			}
		}
		while (dashNo != cDashNo);
	}
	inGap = dashs[dashNo].gap;
}
